/*
 *
 *   qrash: the second portable demo in the world
 *
 *   Copyright (C) 1997  Queue Members Group Art Division
 *   Coded by Mad Max / Queue Members Group (Mike Shirobokov)
 *   <mad_max@qmg.rising.ru>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <fcntl.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>
#include "misc.h"
#include "music.h"
#include "video.h"
#include "resource.h"
#include "mikmod/mikmod.h"
#include <vga.h>

void sysStartup()
{
  puts( "\n"PROJECT_NAME". (c)97 Queue Members Group Art Division\n" );
  sysResetTimer();
}

extern size_t allocated, max_alloc;

void sysCleanup()
{
  if( sysDebug )
    printf( "Memory allocated: now=%d, max=%d\n", allocated, max_alloc );
  exit(0);
}

uint
sysCurrentTime()
{
  timeval tv;
  gettimeofday(&tv,0);
  return (tv.tv_sec*1000+tv.tv_usec/1000);
}

KB sysGetKey()
{
  timeval tv = {0,0};
  fd_set fds;
  FD_ZERO(&fds);
  FD_SET(0,&fds);
  int key = KB_NONE;
  while( vga_waitevent( VGA_KEYEVENT, &fds, 0, 0, &tv ) > 0 ) {
    key = toupper(vga_getch());
  }
  switch(key) {
    case '+': return KB_PLUS;
    case '-': return KB_MINUS;
    case 133: 
    case 'G': return KB_F11;
    case 27:  return KB_ESC;
  }
  return KB_NONE;
}

char cmdline[2048] = "";

void main( int argc, char* argv[] )
{
  for( int i=1; i<argc; i++ ) {
    strcat( cmdline, argv[i] );
  }
  Startup( cmdline );
  sysMain( argc, argv );
  Shutdown();
}
